import java.awt.*;
import java.awt.geom.*;

class GBall extends Ball implements Drawable {
   private float radius;
   private float mass;
   /**
    * En la version previa todas las bolas eran azules.
    * Ahora solo aquella que esta siendo graficada es azul, las otras son naranjas.
    */
   private Color color = Color.ORANGE;
   private Ellipse2D.Float shape = null;
   
   public GBall (float mass, Vector2D position, Vector2D speed, 
                  float radius){
	  
      super(mass, position, speed);
      this.radius = radius;
      this.mass=mass;
      setCrossSection(6*Math.PI*radius);
      shape = new Ellipse2D.Float((float)getX()-radius, (float)getY()-radius, 2*radius, 2*radius);
   }
   public void draw (Graphics2D g){
      shape.setFrame((float)getX()-radius, (float)getY()-radius, 2*radius, 2*radius);
      
      g.setColor(color);
      g.fill(shape);
      g.setColor(Color.WHITE);
      //Marcamos la masa en la bola
      g.drawString(String.valueOf(this.mass),(int) getX()-radius+2, (int)getY()+4);
      
   }
   public boolean contains (int x, int y){
      return shape.contains(x,y);
   }
   public void dragTo(int x, int y){
      setPosition(x,y);
   }
   public void setSelected (){
      color = Color.RED;
   }
   public void setReleased() {
      color = Color.ORANGE;
   }
   //para poder modificar la masa de la bola
   public void setMass(float mass){
	   this.mass =mass;
   }
   
   /**
    * Cambia la bola a color si es seleccionada o no. 
    * Bola Azul: Seleccionada para graficarse
    * Bola Naranja: No se grafica.
    * @param t Si es seleccionada true, sino es seleccionada false. 
    */
   public void plot(boolean t){
	   if(t) color=Color.blue;
	   else color=Color.ORANGE;
	  
   }  
}